/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  lpixport.t

\***************************************************************************/

#if !defined(LPIXPORT_T)
#define LPIXPORT_T
/********************************************************************
**             FILE INCLUDES
*/
typedef lubyte stacktype ;
typedef
   union
   {
      lfloat10 tr ;
      lfloat8  lr ;
      lfloat4  sr ;
   }
number ;
typedef number * numptr ;
/*
   The types of string compares available (and used) in tos_compare.
   NUM_COLLATING uses the collating compare (where an umlauted a comes just
   after a normal a).
   NUM_CHARSET uses the character set's sequence (where an umlauted a is
   near the end of the sequence).
   NUM_DBASE is just like NUM_COLLATING except that blanks are treated
   as NA.
*/
typedef enum
   {
   NUM_COLLATING, NUM_FULL_COLLATE, NUM_CHARSET, NUM_WILDCARD, NUM_DBASE
   } strcmp_type;
/*
   THese are the stacktypes below.
*/
#define NOTUSED      0x00     /* for table stuff only */
#define NUM_TREAL    0x01
#define NUM_ERR      0x40
#define NUM_NA       0x80
#define     NOPARAMS    void
void        drop_one(NOPARAMS) ;
void        drop_many(lsshort);
lsshort     pop_integer(NOPARAMS) ;     /* pop integer value on stack (rounds) */
lslong      pop_long(NOPARAMS) ;        /* pop long integer value on stack (rounds)*/
lbool       pop_double(lptr(lfloat8)) ;    /* pop IEEE double precision float */
stacktype   pop_number(lptr(lfloat10)) ;       /* ten byte real into memory */
stacktype   tos_type(NOPARAMS) ;
lsshort     push_long(lslong) ;
lsshort     push_integer(lsshort) ;
void        push_type_err(NOPARAMS);
void        push_na(NOPARAMS);
void        push_number_value(lptr(lfloat10)); /* push a formula value which is a number */
void        push_zero(NOPARAMS) ;
void        push_one(NOPARAMS) ;
void        push_pi(NOPARAMS);
lsshort     push_double(lptr(lfloat8)) ;
void  op_negate(NOPARAMS),
      op_pow(NOPARAMS),
      op_eq(NOPARAMS),
      op_neq(NOPARAMS),
      op_lte(NOPARAMS),
      op_gte(NOPARAMS),
      op_lt(NOPARAMS),
      op_gt(NOPARAMS);
void at_sqrt     (lsshort);
void at_ln       (lsshort);
void at_mod      (lsshort);
void at_log      (lsshort);
void at_exp      (lsshort);
void at_sin      (lsshort);
void at_cos      (lsshort);
void at_tan      (lsshort);
void at_asin     (lsshort);
void at_acos     (lsshort);
void at_atan     (lsshort);
void at_atan2    (lsshort);
void at_abs      (lsshort);
void at_int      (lsshort);
void at_rand     (lsshort);
void  op_add(NOPARAMS),
      op_sub(NOPARAMS),
      op_mul(NOPARAMS),
      op_div(NOPARAMS);
stacktype swap(NOPARAMS) ;
stacktype swap_nth(lsshort) ;
stacktype gdup(NOPARAMS) ;
stacktype dup_nth(lsshort) ;
lsshort tos_compare(strcmp_type) ;  /* compares top two elements of stack */
stacktype stack_depth(NOPARAMS) ;
/********************************************************************
**             DATA STRUCTURES
*/
void lts_temp(void);
typedef struct MathTable_
   {
   void          (far *lts_temp0)        (void);
   void          (far *lts_temp1)        (void);
   void          (far *lts_temp2)        (void);
   void          (far *lts_temp3)        (void);
   void          (far *lts_temp4)        (void);
   void          (far *lts_temp5)        (void);
   void          (far *lts_temp6)        (void);
   void          (far *lts_temp7)        (void);
   void          (far *lts_temp8)        (void);
   void          (far *lts_temp9)        (void);
   void          (far *lts_temp10)       (void);
   void          (far *lts_temp11)       (void);
   void          (far *lts_temp12)       (void);
   void          (far *lts_temp13)       (void);
   void          (far *lts_temp14)       (void);
   void          (far *lts_temp15)       (void);
   void          (far *lts_temp16)       (void);
   void          (far *lts_temp17)       (void);
   void          (far *lts_temp18)       (void);
   void          (far *lts_temp19)       (void);
   void          (far *lts_temp20)       (void);
   void          (far *lts_temp21)       (void);
   void          (far *lts_temp22)       (void);
   void          (far *lts_temp23)       (void);
   void          (far *lts_temp24)       (void);
   void          (far *lts_temp25)       (void);
   void          (far *lts_temp26)       (void);
   void          (far *lts_temp27)       (void);
   void          (far *lts_temp28)       (void);
   void          (far *lts_temp29)       (void);
   void          (far *drop_one)         (void ) ;
   void          (far *drop_many)        (lsshort );
   lsshort       (far *pop_integer)      (void );
   lslong        (far *pop_long)         (void );
   lbool         (far *pop_double)       (lptr(lfloat8) );
   stacktype     (far *pop_number)       (lptr(lfloat10) );
   void          (far *lts_temp36)       (void);
   stacktype     (far *tos_type)         (void );
   lsshort       (far *push_long)        (lslong );
   lsshort       (far *push_integer)     (lsshort );
   void          (far *lts_temp40)       (void);
   void          (far *push_type_err)    (void);
   void          (far *push_na)          (void);
   void          (far *lts_temp43)       (void);
   void          (far *push_number_value)(lptr(lfloat10));
   void          (far *push_zero)        (void) ;
   void          (far *push_one)         (void) ;
   void          (far *push_pi)          (void);
   lsshort       (far *push_double)      (lptr(lfloat8)) ;
   void          (far *lts_temp49)       (void);
   void          (far *op_negate)        (void);
   void          (far *op_pow)           (void);
   void          (far *op_eq)            (void);
   void          (far *op_neq)           (void);
   void          (far *op_lte)           (void);
   void          (far *op_gte)           (void);
   void          (far *op_lt)            (void);
   void          (far *op_gt)            (void);
   void          (far *lts_temp59)       (void);
   void          (far *lts_temp60)       (void);
   void          (far *lts_temp61)       (void);
   void          (far *at_sqrt)         (lsshort);
   void          (far *at_ln)           (lsshort);
   void          (far *at_mod)          (lsshort);
   void          (far *at_log)          (lsshort);
   void          (far *at_exp)          (lsshort);
   void          (far *at_sin)          (lsshort);
   void          (far *at_cos)          (lsshort);
   void          (far *at_tan)          (lsshort);
   void          (far *at_asin)         (lsshort);
   void          (far *at_acos)         (lsshort);
   void          (far *at_atan)         (lsshort);
   void          (far *at_atan2)        (lsshort);
   void          (far *at_abs)          (lsshort);
   void          (far *at_int)          (lsshort);
   void          (far *at_rand)         (lsshort);
   void          (far *op_add)          (void);
   void          (far *op_sub)          (void);
   void          (far *op_mul)          (void);
   void          (far *op_div)          (void);
   } MathTableType;
#define LPI_MATH(func)  (*lpimathtable->func)
#define LPI_MATH_1ARG(func)  (*lpimathtable->func)(1)
#define LpiDropOne                     LPI_MATH (drop_one)
#define LpiDropMany                    LPI_MATH (drop_many)
#define LpiTosType                     LPI_MATH (tos_type)
#define LpiPopLsShort                  LPI_MATH (pop_integer)
#define LpiPopLsLong                   LPI_MATH (pop_long)
#define LpiPopLfloat8                  LPI_MATH (pop_double)
#define LpiPopLfloat10                 LPI_MATH (pop_number)
#define LpiPushLsLong                  LPI_MATH (push_long)
#define LpiPushLsShort                 LPI_MATH (push_integer)
#define LpiPushErr                     LPI_MATH (push_type_err)
#define LpiPushNa                      LPI_MATH (push_na)
#define LpiPushLfloat10                LPI_MATH (push_number_value)
#define LpiPushZero                    LPI_MATH (push_zero)
#define LpiPushOne                     LPI_MATH (push_one)
#define LpiPushPi                      LPI_MATH (push_pi)
#define LpiPushLfloat8                 LPI_MATH (push_double)
#define LpiNegate                      LPI_MATH (op_negate)
#define LpiPow                         LPI_MATH (op_pow)
#define LpiEq                          LPI_MATH (op_eq)
#define LpiNeq                         LPI_MATH (op_neq)
#define LpiLte                         LPI_MATH (op_lte)
#define LpiGte                         LPI_MATH (op_gte)
#define LpiLt                          LPI_MATH (op_lt)
#define LpiGt                          LPI_MATH (op_gt)
#define LpiSqrt()                      LPI_MATH_1ARG (at_sqrt)
#define LpiLN()                        LPI_MATH_1ARG (at_ln)
#define LpiMod()                       LPI_MATH_1ARG(at_mod)
#define LpiLog()                       LPI_MATH_1ARG (at_log)
#define LpiExp()                       LPI_MATH_1ARG (at_exp)
#define LpiSin()                       LPI_MATH_1ARG (at_sin)
#define LpiCos()                       LPI_MATH_1ARG (at_cos)
#define LpiTan()                       LPI_MATH_1ARG (at_tan)
#define LpiASin()                      LPI_MATH_1ARG (at_asin)
#define LpiACos()                      LPI_MATH_1ARG (at_acos)
#define LpiATan()                      LPI_MATH_1ARG (at_atan)
#define LpiATan2()                     LPI_MATH_1ARG (at_atan2)
#define LpiAbs()                       LPI_MATH_1ARG (at_abs)
#define LpiInt()                       LPI_MATH_1ARG (at_int)
#define LpiRand()                      LPI_MATH_1ARG (at_rand)
#define LpiAdd                         LPI_MATH (op_add)
#define LpiSub                         LPI_MATH (op_sub)
#define LpiMul                         LPI_MATH (op_mul)
#define LpiDiv                         LPI_MATH (op_div)
typedef struct MathTable2_
   {
   void          (far *lts2_temp0)        (void);
   void          (far *lts2_temp1)        (void);
   void          (far *lts2_temp2)        (void);
   void          (far *lts2_temp3)        (void);
   void          (far *lts2_temp4)        (void);
   void          (far *lts2_temp5)        (void);
   void          (far *lts2_temp6)        (void);
   void          (far *lts2_temp7)        (void);
   void          (far *lts2_temp8)        (void);
   void          (far *lts2_temp9)        (void);
   void          (far *lts2_temp10)       (void);
   void          (far *lts2_temp11)       (void);
   void          (far *lts2_temp12)       (void);
   void          (far *lts2_temp13)       (void);
   void          (far *lts2_temp14)       (void);
   void          (far *lts2_temp15)       (void);
   void          (far *lts2_temp16)       (void);
   void          (far *lts2_temp17)       (void);
   void          (far *lts2_temp18)       (void);
   void          (far *lts2_temp19)       (void);
   void          (far *lts2_temp20)       (void);
   void          (far *lts2_temp21)       (void);
   void          (far *lts2_temp22)       (void);
   void          (far *lts2_temp23)       (void);
   void          (far *lts2_temp24)       (void);
   void          (far *lts2_temp25)       (void);
   void          (far *lts2_temp26)       (void);
   void          (far *lts2_temp27)       (void);
   void          (far *lts2_temp28)       (void);
   void          (far *lts2_temp29)       (void);
   void          (far *lts2_temp30)       (void);
   void          (far *lts2_temp31)       (void);
   void          (far *lts2_temp32)       (void);
   void          (far *lts2_temp33)       (void);
   void          (far *lts2_temp34)       (void);
   void          (far *lts2_temp35)       (void);
   void          (far *lts2_temp36)       (void);
   void          (far *lts2_temp37)       (void);
   void          (far *lts2_temp38)       (void);
   void          (far *lts2_temp39)       (void);
   void          (far *lts2_temp40)       (void);
   void          (far *lts2_temp41)       (void);
   void          (far *lts2_temp42)       (void);
   void          (far *lts2_temp43)       (void);
   void          (far *lts2_temp44)       (void);
   void          (far *lts2_temp45)       (void);
   void          (far *lts2_temp46)       (void);
   void          (far *lts2_temp47)       (void);
   void          (far *lts2_temp48)       (void);
   void          (far *lts2_temp49)       (void);
   void          (far *lts2_temp50)       (void);
   void          (far *lts2_temp51)       (void);
   void          (far *lts2_temp52)       (void);
   void          (far *lts2_temp53)       (void);
   void          (far *lts2_temp54)       (void);
   void          (far *lts2_temp55)       (void);
   void          (far *lts2_temp56)       (void);
   void          (far *lts2_temp57)       (void);
   void          (far *lts2_temp58)       (void);
   void          (far *lts2_temp59)       (void);
   void          (far *lts2_temp60)       (void);
   void          (far *lts2_temp61)       (void);
   void          (far *lts2_temp62)       (void);
   void          (far *lts2_temp63)       (void);
   void          (far *lts2_temp64)       (void);
   void          (far *lts2_temp65)       (void);
   void          (far *lts2_temp66)       (void);
   void          (far *lts2_temp67)       (void);
   void          (far *lts2_temp68)       (void);
   void          (far *lts2_temp69)       (void);
   void          (far *lts2_temp70)       (void);
   void          (far *lts2_temp71)       (void);
   void          (far *lts2_temp72)       (void);
   void          (far *lts2_temp73)       (void);
   void          (far *lts2_temp74)       (void);
   void          (far *lts2_temp75)       (void);
   void          (far *lts2_temp76)       (void);
   void          (far *lts2_temp77)       (void);
   void          (far *lts2_temp78)       (void);
   void          (far *lts2_temp79)       (void);
   void          (far *lts2_temp80)       (void);
   void          (far *lts2_temp81)       (void);
   void          (far *lts2_temp82)       (void);
   void          (far *lts2_temp83)       (void);
   void          (far *lts2_temp84)       (void);
   void          (far *lts2_temp85)       (void);
   void          (far *lts2_temp86)       (void);
   void          (far *lts2_temp87)       (void);
   void          (far *lts2_temp88)       (void);
   void          (far *lts2_temp89)       (void);
   void          (far *lts2_temp90)       (void);
   void          (far *lts2_temp91)       (void);
   void          (far *lts2_temp92)       (void);
   void          (far *lts2_temp93)       (void);
   void          (far *lts2_temp94)       (void);
   void          (far *lts2_temp95)       (void);
   void          (far *lts2_temp96)       (void);
   void          (far *lts2_temp97)       (void);
   void          (far *lts2_temp98)       (void);
   void          (far *lts2_temp99)       (void);
   void          (far *lts2_temp100)       (void);
   void          (far *lts2_temp101)       (void);
   void          (far *lts2_temp102)       (void);
   void          (far *lts2_temp103)       (void);
   void          (far *lts2_temp104)       (void);
   void          (far *lts2_temp105)       (void);
   void          (far *lts2_temp106)       (void);
   void          (far *lts2_temp107)       (void);
   void          (far *lts2_temp108)       (void);
   void          (far *lts2_temp109)       (void);
   void          (far *lts2_temp110)       (void);
   void          (far *lts2_temp111)       (void);
   void          (far *lts2_temp112)       (void);
   void          (far *lts2_temp113)       (void);
   void          (far *lts2_temp114)       (void);
   void          (far *lts2_temp115)       (void);
   void          (far *lts2_temp116)       (void);
   void          (far *lts2_temp117)       (void);
   void          (far *lts2_temp118)       (void);
   void          (far *lts2_temp119)       (void);
   void          (far *lts2_temp120)       (void);
   void          (far *lts2_temp121)       (void);
   void          (far *lts2_temp122)       (void);
   void          (far *lts2_temp123)       (void);
   void          (far *lts2_temp124)       (void);
   void          (far *lts2_temp125)       (void);
   void          (far *lts2_temp126)       (void);
   void          (far *lts2_temp127)       (void);
   void          (far *lts2_temp128)       (void);
   void          (far *lts2_temp129)       (void);
   void          (far *lts2_temp130)       (void);
   void          (far *lts2_temp131)       (void);
   void          (far *lts2_temp132)       (void);
   void          (far *lts2_temp133)       (void);
   void          (far *lts2_temp134)       (void);
   void          (far *lts2_temp135)       (void);
   void          (far *lts2_temp136)       (void);
   void          (far *lts2_temp137)       (void);
   void          (far *lts2_temp138)       (void);
   void          (far *lts2_temp139)       (void);
   void          (far *lts2_temp140)       (void);
   void          (far *lts2_temp141)       (void);
   void          (far *lts2_temp142)       (void);
   void          (far *lts2_temp143)       (void);
   void          (far *lts2_temp144)       (void);
   void          (far *lts2_temp145)       (void);
   void          (far *lts2_temp146)       (void);
   void          (far *lts2_temp147)       (void);
   void          (far *lts2_temp148)       (void);
   void          (far *lts2_temp149)       (void);
   void          (far *lts2_temp150)       (void);
   void          (far *lts2_temp151)       (void);
   void          (far *lts2_temp152)       (void);
   void          (far *lts2_temp153)       (void);
   void          (far *lts2_temp154)       (void);
   void          (far *lts2_temp155)       (void);
   void          (far *lts2_temp156)       (void);
   void          (far *lts2_temp157)       (void);
   void          (far *lts2_temp158)       (void);
   void          (far *lts2_temp159)       (void);
   void          (far *lts2_temp160)       (void);
   void          (far *lts2_temp161)       (void);
   void          (far *lts2_temp162)       (void);
   stacktype (far *swap)                   (NOPARAMS) ;
   stacktype (far *swap_nth)               (lsshort) ;
   stacktype (far *gdup)                   (NOPARAMS);
   stacktype (far *dup_nth)                (lsshort);
   lsshort   (far *tos_compare)            (strcmp_type);
   stacktype (far *stack_depth)            (NOPARAMS);
   } MathTableType2;
#define LPI_MATH2(func)  (*lpimathtable2->func)
#define LPI_MATH2_1ARG(func)  (*lpimathtable2->func)(NUM_COLLATING)
#define LpiSwap                         LPI_MATH2 (swap)
#define LpiSwapNth                      LPI_MATH2 (swap_nth)
#define LpiDup                          LPI_MATH2 (gdup)
#define LpiDupNth                       LPI_MATH2 (dup_nth)
#define LpiTosCompare()                 LPI_MATH2_1ARG (tos_compare)
#define LpiStackDepth                   LPI_MATH2 (stack_depth)
/********************************************************************
**             END OF FILE
*/
#endif   /* if !defined(LPIXPORT_T) */
