/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  comxport.h

   1.  Lotus grants you a non-exclusive royalty-free right to use and modify
       the source code version and to reproduce and distribute the object
       code version of the Example Programs provided in the Toolkit, provided
       that you:

       a) distribute the Example Programs only in conjunction with and as a
          part of your software application product which is designed as an
          add-in to Lotus 1-2-3, and

       b) do not represent your product to be a product of Lotus Development
          Corporation.

   2.  The Example Programs are provided as is, without warranty of any kind,
       either express or implied, including, without limitation, the implied
       warranties of merchantability of fitness for a particular purpose.

\***************************************************************************/


#if !defined(COMXPORT_H)
#define COMXPORT_H

/* ****************************  GLOBAL TYPEDEFS ************************* */
/* Defining a structure in this manner allows the C compiler to
 * perform strong type checking, yet does not publish the contents
 * of instance data to external users.
 */
typedef lptr(struct LpiCommportType_)       LpiCommportType;



/* ************************* DEFINE THE "USE" MACROS ********************* */
#if defined(USE_COMMPORT)
#include "commport.plx"
#endif



#if defined(NOGLOBALDATA)       /* if global data is not allowed */
/* ****************  DECLARE VARIABLES FOR NOGLOBALDATA  *************** */
/* The lpiglobaldatatype structure has its contents conditionally defined,
 * depending on which libraries the user has requested.  The USE_COMMPORT
 * macro (defined above) includes the PLX files with the needed definitions
 * and defines the COMMPORT_PLX symbol, which then determines the contents
 * of the lpiglobaldatatype structure.
 *
 * The following variables will contain pointers to the export tables
 * defined in the .PLX file and to the LpiContext unique to the
 * primitive being called.
 *
 */

/* *********************************************************************
 * Add the following to the lpiglobaldatatype structure in lpixport.h:

#if defined(COMMPORT_PLX)
    lptr(cp_exports)    cp_table;
    lptr(CONTEXT)      cp_global;
#endif

 * ********************************************************************* */



/* ****************  DEFINE SETUP MACRO FOR NOGLOBALDATA *************** */
#define LPI_LOAD_COMMPORT      LpiSetupAltCall(ll3commport_name, &(LPI_CALL_DATA->cp_table),\
                                        &(LPI_CALL_DATA->cp_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )



#else           /* for use with global data */
/* ****************  DECLARE VARIABLES FOR GLOBAL DATA OK *************** */

/* The following variables will contain pointers to the export tables
 * defined in the .PLX file and to the LpiContext unique to the
 * primitive being called.
 */

/* COMMPORT */
#if defined(COMMPORT_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(cp_exports)    lts_cp_table = LNULL;
    lptr(CONTEXT)       lts_cp_global = LNULL;
#else
    extern lptr(cp_exports)    lts_cp_table;
    extern lptr(CONTEXT)       lts_cp_global;
#endif
#endif

/* ****************  DEFINE SETUP MACRO FOR GLOBAL DATA OK *************** */
#define LPI_LOAD_COMMPORT      LpiSetupAltCall(ll3commport_name, &lts_cp_table,\
                                        &lts_cp_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )


#endif

/* ***************** END OF DEFINING ALL THE GLOBAL MACROS **************** */
#endif  /* !defined(COMXPORT_H) */

