--**************************************************************************
--
--   Copyright (C) 1991-1994 Lotus Development Corporation.
--   All rights reserved.
--
--   1.  Lotus grants you a non-exclusive royalty-free right to use and modify
--       the source code version and to reproduce and distribute the object
--       code version of the Example Programs provided in the Toolkit, provided
--       that you:
--
--       a) distribute the Example Programs only in conjunction with and as a
--          part of your software application product which is designed as an
--          add-in to Lotus 1-2-3, and
--
--       b) do not represent your product to be a product of Lotus Development
--          Corporation.
--
--   2.  The Example Programs are provided as is, without warranty of any kind,
--       either express or implied, including, without limitation, the implied
--       warranties of merchantability of fitness for a particular purpose.
--
--   File Name:  xdegrees.pl
--
--**************************************************************************

module Xdegrees is


-- This module defines 1 @function.


    Use Register   -- contains the register procedure, which informs 1-2-3
                   -- that this add-in is an @function or macro

------------------------------------------------------------------------------
------------------------------------------------------------------------------
procedure Initialize is

 begin
   register("Degrees", at_function)
 end
  except on others (string SignalName) do
    Print("Signal ", SignalName, " raised.")
    end except
end procedure Initialize


procedure Degrees (float TempIn, string Scale)
                   returns (float TempOut) is

-- If Scale is ftoc or FTOC (Fahrenheit), convert TempIn from Fahrenheit to
-- Centigrade.  If Scale is CTOF or ctof, convert TempIn from Centigrade to
-- Fahrenheit.  All other Scales result in ERR.

 begin
       if Scale = "FTOC" | Scale = "ftoc" then
    TempOut = 5/9 * (TempIn - 32)
  elseif Scale = "CTOF" | Scale = "ctof" then
    TempOut = (9/5 * TempIn) + 32
  else TempOut = err

       end if
 end
  except on others (string SignalName) do
    Print("Signal ", SignalName, " raised.")
    end except

 end procedure Degrees

end module Xdegrees
